searchNodes=[{"doc":"Documentation for Ergo .","ref":"Ergo.html","title":"Ergo","type":"module"},{"doc":"Hello world. Examples iex&gt; Ergo . hello ( ) :world","ref":"Ergo.html#hello/0","title":"Ergo.hello/0","type":"function"},{"doc":"","ref":"Ergo.Combinators.html","title":"Ergo.Combinators","type":"module"},{"doc":"The choice/1 parser takes a list of parsers. It tries each in order attempting to match one. Once a match has been made choice returns the result of the matching parser. Examples iex&gt; alias Ergo.Context iex&gt; import Ergo . { Terminals , Parsers , Combinators } iex&gt; context = Context . new ( &quot;Hello World&quot; ) iex&gt; parser = choice ( [ literal ( &quot;Foo&quot; ) , literal ( &quot;Bar&quot; ) , literal ( &quot;Hello&quot; ) , literal ( &quot;World&quot; ) ] ) iex&gt; parser . ( context ) % Context { status : :ok , ast : &quot;Hello&quot; , input : &quot; World&quot; , char : ?o , index : 5 , col : 6 } iex&gt; alias Ergo.Context iex&gt; import Ergo . { Terminals , Parsers , Combinators } iex&gt; context = Context . new ( &quot;Hello World&quot; ) iex&gt; parser = choice ( [ literal ( &quot;Foo&quot; ) , literal ( &quot;Bar&quot; ) ] ) iex&gt; parser . ( context ) % Context { status : { :error , :no_valid_choice } , message : &quot;No valid choice&quot; , ast : nil , input : &quot;Hello World&quot; }","ref":"Ergo.Combinators.html#choice/2","title":"Ergo.Combinators.choice/2","type":"function"},{"doc":"The ignore/1 parser matches but ignores the AST of its child parser. Examples iex&gt; alias Ergo.Context iex&gt; import Ergo . { Terminals , Combinators , Parsers } iex&gt; context = Context . new ( &quot;Hello World&quot; ) iex&gt; parser = sequence ( [ literal ( &quot;Hello&quot; ) , ignore ( ws ( ) ) , literal ( &quot;World&quot; ) ] ) iex&gt; parser . ( context ) % Context { status : :ok , ast : [ &quot;Hello&quot; , &quot;World&quot; ] , index : 11 , col : 12 , char : ?d }","ref":"Ergo.Combinators.html#ignore/1","title":"Ergo.Combinators.ignore/1","type":"function"},{"doc":"The lookahead parser accepts a parser and matches it but does not update the context when it succeeds. Example iex&gt; alias Ergo . { Context , Terminals , Combinators } iex&gt; context = Context . new ( &quot;Hello World&quot; ) iex&gt; parser = Combinators . lookahead ( Terminals . literal ( &quot;Hello&quot; ) ) iex&gt; parser . ( context ) % Context { status : :ok , ast : nil , input : &quot;Hello World&quot; , char : 0 , index : 0 , line : 1 , col : 1 } iex&gt; alias Ergo . { Context , Terminals , Combinators } iex&gt; context = Context . new ( &quot;Hello World&quot; ) iex&gt; parser = Combinators . lookahead ( Terminals . literal ( &quot;Helga&quot; ) ) iex&gt; parser . ( context ) % Context { status : { :error , :lookahead_fail } , ast : [ ?l , ?e , ?H ] , char : ?l , index : 3 , col : 4 , input : &quot;lo World&quot; }","ref":"Ergo.Combinators.html#lookahead/1","title":"Ergo.Combinators.lookahead/1","type":"function"},{"doc":"Examples iex&gt; alias Ergo . { Context , Combinators } iex&gt; context = Context . new ( &quot;Hello World&quot; ) iex&gt; parser = Combinators . many ( Ergo.Terminals . wc ( ) ) iex&gt; parser . ( context ) % Context { status : :ok , ast : [ ?H , ?e , ?l , ?l , ?o ] , input : &quot; World&quot; , index : 5 , col : 6 , char : ?o } iex&gt; alias Ergo . { Context , Terminals , Combinators } iex&gt; context = Context . new ( &quot;Hello World&quot; ) iex&gt; parser = Combinators . many ( Terminals . wc ( ) , min : 6 ) iex&gt; parser . ( context ) % Context { status : { :error , :many_less_than_min } , ast : nil , input : &quot; World&quot; , char : ?o , index : 5 , col : 6 } iex&gt; alias Ergo . { Context , Terminals , Combinators } iex&gt; context = Context . new ( &quot;Hello World&quot; ) iex&gt; parser = Combinators . many ( Terminals . wc ( ) , max : 3 ) iex&gt; parser . ( context ) % Context { status : :ok , ast : [ ?H , ?e , ?l ] , input : &quot;lo World&quot; , char : ?l , index : 3 , col : 4 } iex&gt; alias Ergo . { Context , Combinators } iex&gt; context = Context . new ( &quot;Hello World&quot; ) iex&gt; parser = Combinators . many ( Ergo.Terminals . wc ( ) , map : &amp; Enum . count / 1 ) iex&gt; parser . ( context ) % Context { status : :ok , ast : 5 , input : &quot; World&quot; , index : 5 , col : 6 , char : ?o }","ref":"Ergo.Combinators.html#many/2","title":"Ergo.Combinators.many/2","type":"function"},{"doc":"The not_lookahead parser accepts a parser and attempts to match it. If the match fails the not_lookahead parser returns status: :ok but does not affect the context otherwise. If the match succeeds the not_lookahead parser fails with {:error, :lookahead_fail} Examples iex&gt; alias Ergo.{Context, Terminals, Combinators} iex&gt; context = Context.new(&quot;Hello World&quot;) iex&gt; parser = Combinators.not_lookahead(Terminals.literal(&quot;Foo&quot;)) iex&gt; parser.(context) %Context{status: :ok, input: &quot;Hello World&quot;} iex&gt; alias Ergo.{Context, Terminals, Combinators} iex&gt; context = Context.new(&quot;Hello World&quot;) iex&gt; parser = Combinators.not_lookahead(Terminals.literal(&quot;Hello&quot;)) iex&gt; parser.(context) %Context{status: {:error, :lookahead_fail}, input: &quot;Hello World&quot;}","ref":"Ergo.Combinators.html#not_lookahead/1","title":"Ergo.Combinators.not_lookahead/1","type":"function"},{"doc":"Examples iex&gt; alias Ergo . { Context , Terminals , Combinators } iex&gt; context = Context . new ( &quot;Hello World&quot; ) iex&gt; parser = Combinators . optional ( Terminals . literal ( &quot;Hello&quot; ) ) iex&gt; parser . ( context ) % Context { status : :ok , ast : &quot;Hello&quot; , input : &quot; World&quot; , index : 5 , col : 6 , char : ?o } iex&gt; alias Ergo . { Context , Terminals , Combinators } iex&gt; context = Context . new ( &quot; World&quot; ) iex&gt; parser = Combinators . optional ( Terminals . literal ( &quot;Hello&quot; ) ) iex&gt; parser . ( context ) % Context { status : :ok , ast : nil , input : &quot; World&quot; , index : 0 , col : 1 , char : 0 }","ref":"Ergo.Combinators.html#optional/2","title":"Ergo.Combinators.optional/2","type":"function"},{"doc":"","ref":"Ergo.Combinators.html#parse_many/5","title":"Ergo.Combinators.parse_many/5","type":"function"},{"doc":"Examples iex&gt; alias Ergo.Context iex&gt; import Ergo . { Terminals , Combinators , Parsers } iex&gt; context = Context . new ( &quot;Hello World&quot; ) iex&gt; parser = sequence ( [ literal ( &quot;Hello&quot; ) , ws ( ) , literal ( &quot;World&quot; ) ] ) iex&gt; parser . ( context ) % Context { status : :ok , ast : [ &quot;Hello&quot; , ?\\s , &quot;World&quot; ] , char : ?d , index : 11 , line : 1 , col : 12 } iex&gt; alias Ergo.Context iex&gt; import Ergo . { Terminals , Combinators , Parsers } iex&gt; context = Context . new ( &quot;Hello World&quot; ) iex&gt; parser = sequence ( [ literal ( &quot;Hello&quot; ) , ws ( ) , literal ( &quot;World&quot; ) ] , map : fn ast -&gt; Enum . join ( ast , &quot; &quot; ) end ) iex&gt; parser . ( context ) % Context { status : :ok , ast : &quot;Hello 32 World&quot; , char : ?d , index : 11 , line : 1 , col : 12 }","ref":"Ergo.Combinators.html#sequence/2","title":"Ergo.Combinators.sequence/2","type":"function"},{"doc":"The transform/2 parser runs a transforming function on the AST of its child parser. Examples # Sum the digits iex&gt; alias Ergo . { Context , Terminals , Combinators } iex&gt; digit_to_int = fn d -&gt; List . to_string ( [ d ] ) |&gt; String . to_integer ( ) end iex&gt; t_fn = fn ast -&gt; ast |&gt; Enum . map ( digit_to_int ) |&gt; Enum . sum ( ) end iex&gt; context = Context . new ( &quot;1234&quot; ) iex&gt; parser_1 = Combinators . sequence ( [ Terminals . digit ( ) , Terminals . digit ( ) , Terminals . digit ( ) , Terminals . digit ( ) ] ) iex&gt; parser_2 = Combinators . transform ( parser_1 , t_fn ) iex&gt; parser_2 . ( context ) % Context { status : :ok , ast : 10 , char : ?4 , index : 4 , line : 1 , col : 5 }","ref":"Ergo.Combinators.html#transform/2","title":"Ergo.Combinators.transform/2","type":"function"},{"doc":"","ref":"Ergo.Context.html","title":"Ergo.Context","type":"module"},{"doc":"Because we build ASTs using lists they end up in reverse order. This method reverses the AST back to in-parse-order Examples iex&gt; context = Ergo.Context . new ( ) ...&gt; context = %{ context | ast : [ 4 , 3 , 2 , 1 ] } ...&gt; Context . ast_in_parsed_order ( context ) % Context { ast : [ 1 , 2 , 3 , 4 ] }","ref":"Ergo.Context.html#ast_in_parsed_order/1","title":"Ergo.Context.ast_in_parsed_order/1","type":"function"},{"doc":"Where an AST has been built from individual characters and needs to be converted to a string Examples iex&gt; context = Ergo.Context . new ( ) iex&gt; context = %{ context | ast : [ ?H , ?e , ?l , ?l , ?o ] } iex&gt; Context . ast_to_string ( context ) % Context { ast : &quot;Hello&quot; }","ref":"Ergo.Context.html#ast_to_string/1","title":"Ergo.Context.ast_to_string/1","type":"function"},{"doc":"Called to perform an arbitrary transformation on the AST value of a Context. Examples iex&gt; alias Ergo.Context iex&gt; context = Context . new ( ) iex&gt; context = %{ context | ast : &quot;Hello World&quot; } iex&gt; Context . ast_transform ( context , &amp; Function . identity / 1 ) % Context { ast : &quot;Hello World&quot; } iex&gt; alias Ergo.Context iex&gt; context = Context . new ( ) iex&gt; context = %{ context | ast : &quot;Hello World&quot; } iex&gt; Context . ast_transform ( context , &amp; String . length / 1 ) % Context { ast : 11 } iex&gt; alias Ergo.Context iex&gt; context = Context . new ( ) iex&gt; context = %{ context | ast : &quot;Hello World&quot; } iex&gt; Context . ast_transform ( context , nil ) % Context { ast : &quot;Hello World&quot; }","ref":"Ergo.Context.html#ast_transform/2","title":"Ergo.Context.ast_transform/2","type":"function"},{"doc":"The ignore parser matches but returns a nil for the AST. Parsers like sequence accumulate these nil values. Call this function to remove them Examples iex&gt; context = Ergo.Context . new ( ) ...&gt; context = %{ context | ast : [ &quot;Hello&quot; , nil , &quot;World&quot; , nil ] } ...&gt; Context . ast_without_ignored ( context ) % Context { ast : [ &quot;Hello&quot; , &quot;World&quot; ] }","ref":"Ergo.Context.html#ast_without_ignored/1","title":"Ergo.Context.ast_without_ignored/1","type":"function"},{"doc":"Examples iex&gt; Context.new() %Context{}","ref":"Ergo.Context.html#new/0","title":"Ergo.Context.new/0","type":"function"},{"doc":"Examples: iex&gt; Context.new(&quot;Hello World&quot;) %Context{status: :ok, input: &quot;Hello World&quot;, line: 1, col: 1, index: 0}","ref":"Ergo.Context.html#new/1","title":"Ergo.Context.new/1","type":"function"},{"doc":"Examples iex&gt; Context.next_char(Context.new()) %Context{status: {:error, :unexpected_eoi}, message: &quot;Unexpected end of input&quot;} iex&gt; Context.next_char(Context.new(&quot;Hello World&quot;)) %Context{status: :ok, input: &quot;ello World&quot;, char: ?H, ast: ?H, index: 1, line: 1, col: 2}","ref":"Ergo.Context.html#next_char/1","title":"Ergo.Context.next_char/1","type":"function"},{"doc":"Examples iex&gt; context = Context . new ( &quot;Hello&quot; ) ...&gt; Context . peek ( context ) % Context { status : :ok , char : ?H , ast : ?H , input : &quot;ello&quot; , index : 1 , line : 1 , col : 2 } iex&gt; context = Context . new ( ) ...&gt; Context . peek ( context ) % Context { status : { :error , :unexpected_eoi } , message : &quot;Unexpected end of input&quot; , index : 0 , line : 1 , col : 1 }","ref":"Ergo.Context.html#peek/1","title":"Ergo.Context.peek/1","type":"function"},{"doc":"The Parsers module exists to house utility parsers that while they are terminals in the sense that they are not parameterised, they internally make use of parsers from the Combinators module.","ref":"Ergo.Parsers.html","title":"Ergo.Parsers","type":"module"},{"doc":"Examples iex&gt; alias Ergo.Context iex&gt; import Ergo.Parsers iex&gt; context = Context . new ( &quot;234.56&quot; ) iex&gt; parser = decimal ( ) iex&gt; assert % Context { status : :ok , ast : 234.56 } = parser . ( context )","ref":"Ergo.Parsers.html#decimal/0","title":"Ergo.Parsers.decimal/0","type":"function"},{"doc":"The digits parser matches a series of at least one digit and returns an enumeration of the digits. Examples iex&gt; alias Ergo . { Context , Parsers } iex&gt; context = Context . new ( &quot;2345&quot; ) iex&gt; parser = Parsers . digits ( ) iex&gt; assert % Context { status : :ok , ast : [ 2 , 3 , 4 , 5 ] } = parser . ( context )","ref":"Ergo.Parsers.html#digits/0","title":"Ergo.Parsers.digits/0","type":"function"},{"doc":"The unit parser matches a series of at least one digit and returns the integer value of the digits. Examples iex&gt; alias Ergo.Context iex&gt; import Ergo.Parsers iex&gt; context = Context . new ( &quot;2345&quot; ) iex&gt; parser = uint ( ) iex&gt; parser . ( context ) % Context { status : :ok , ast : 2345 , char : ?5 , index : 4 , col : 5 }","ref":"Ergo.Parsers.html#uint/0","title":"Ergo.Parsers.uint/0","type":"function"},{"doc":"","ref":"Ergo.Terminals.html","title":"Ergo.Terminals","type":"module"},{"doc":"The alpha/0 parser accepts a single character in the range a..z or A..Z. Examples iex&gt; alias Ergo.Context iex&gt; import Ergo.Terminals iex&gt; context = Context . new ( &quot;Hello World&quot; ) iex&gt; parser = alpha ( ) iex&gt; parser . ( context ) % Context { status : :ok , input : &quot;ello World&quot; , char : ?H , ast : ?H , index : 1 , line : 1 , col : 2 } iex&gt; alias Ergo.Context iex&gt; import Ergo.Terminals iex&gt; context = Context . new ( &quot;ello World&quot; ) iex&gt; parser = alpha ( ) iex&gt; parser . ( context ) % Context { status : :ok , input : &quot;llo World&quot; , char : ?e , ast : ?e , index : 1 , line : 1 , col : 2 } iex&gt; alias Ergo.Context iex&gt; import Ergo.Terminals iex&gt; context = Context . new ( &quot; World&quot; ) iex&gt; parser = alpha ( ) iex&gt; parser . ( context ) % Context { status : { :error , :unexpected_char } , message : &quot;Expected: [a..z, A..Z] Actual: &quot; , input : &quot; World&quot; }","ref":"Ergo.Terminals.html#alpha/0","title":"Ergo.Terminals.alpha/0","type":"function"},{"doc":"The char/1 parser is a terminal parser that matches a specific character. Examples iex&gt; alias Ergo.Context iex&gt; import Ergo.Terminals iex&gt; context = Context . new ( &quot;Hello World&quot; ) iex&gt; parser = char ( ?H ) iex&gt; parser . ( context ) % Context { status : :ok , char : ?H , ast : ?H , input : &quot;ello World&quot; , index : 1 , line : 1 , col : 2 } iex&gt; alias Ergo.Context iex&gt; import Ergo.Terminals iex&gt; context = Context . new ( &quot;Hello World&quot; ) iex&gt; parser = char ( ?h ) iex&gt; parser . ( context ) % Context { status : { :error , :unexpected_char } , message : &quot;Expected: h Actual: H&quot; , input : &quot;Hello World&quot; } iex&gt; alias Ergo.Context iex&gt; import Ergo.Terminals iex&gt; context = Context . new ( ) iex&gt; parser = char ( ?H ) iex&gt; parser . ( context ) % Context { status : { :error , :unexpected_eoi } , message : &quot;Unexpected end of input&quot; } iex&gt; alias Ergo.Context iex&gt; import Ergo.Terminals iex&gt; context = Context . new ( &quot;Hello World&quot; ) iex&gt; parser = char ( ?A .. ?Z ) iex&gt; parser . ( context ) % Context { status : :ok , char : ?H , ast : ?H , input : &quot;ello World&quot; , index : 1 , line : 1 , col : 2 } iex&gt; alias Ergo.Context iex&gt; import Ergo.Terminals iex&gt; context = Context . new ( &quot;Hello World&quot; ) iex&gt; parser = char ( ?a .. ?z ) iex&gt; parser . ( context ) % Context { status : { :error , :unexpected_char } , message : &quot;Expected: a..z Actual: H&quot; , input : &quot;Hello World&quot; } iex&gt; alias Ergo.Context iex&gt; import Ergo.Terminals iex&gt; context = Context . new ( ) iex&gt; parser = char ( ?A .. ?Z ) iex&gt; parser . ( context ) % Context { status : { :error , :unexpected_eoi } , message : &quot;Unexpected end of input&quot; } iex&gt; alias Ergo.Context iex&gt; import Ergo.Terminals iex&gt; context = Context . new ( &quot;Hello World&quot; ) iex&gt; parser = char ( [ ?a .. ?z , ?A .. ?Z ] ) iex&gt; parser . ( context ) % Context { status : :ok , char : ?H , ast : ?H , input : &quot;ello World&quot; , index : 1 , line : 1 , col : 2 } iex&gt; alias Ergo.Context iex&gt; import Ergo.Terminals iex&gt; context = Context . new ( &quot;0000&quot; ) iex&gt; parser = char ( [ ?a .. ?z , ?A .. ?Z ] ) iex&gt; parser . ( context ) % Context { status : { :error , :unexpected_char } , message : &quot;Expected: [a..z, A..Z] Actual: 0&quot; , input : &quot;0000&quot; } iex&gt; alias Ergo.Context iex&gt; import Ergo.Terminals iex&gt; context = Context . new ( &quot;0000&quot; ) iex&gt; parser = char ( - ?0 ) iex&gt; parser . ( context ) % Context { status : { :error , :unexpected_char } , message : &quot;Should not have matched 0&quot; , input : &quot;0000&quot; } iex&gt; alias Ergo.Context iex&gt; import Ergo.Terminals iex&gt; context = Context . new ( &quot;0000&quot; ) iex&gt; parser = char ( - ?a ) iex&gt; parser . ( context ) % Context { status : :ok , input : &quot;000&quot; , ast : ?0 , char : ?0 , index : 1 , col : 2 }","ref":"Ergo.Terminals.html#char/1","title":"Ergo.Terminals.char/1","type":"function"},{"doc":"The digit/0 parser accepts a character in the range of 0..9 Examples iex&gt; alias Ergo.Context iex&gt; import Ergo.Terminals iex&gt; context = Context . new ( &quot;0000&quot; ) iex&gt; parser = digit ( ) iex&gt; parser . ( context ) % Context { status : :ok , char : ?0 , ast : ?0 , input : &quot;000&quot; , index : 1 , line : 1 , col : 2 } iex&gt; alias Ergo.Context iex&gt; import Ergo.Terminals iex&gt; context = Context . new ( &quot;AAAA&quot; ) iex&gt; import Ergo.Terminals iex&gt; parser = digit ( ) iex&gt; parser . ( context ) % Context { status : { :error , :unexpected_char } , message : &quot;Expected: 0..9 Actual: A&quot; , char : 0 , input : &quot;AAAA&quot; , index : 0 , line : 1 , col : 1 } iex&gt; alias Ergo.Context iex&gt; import Ergo.Terminals iex&gt; context = Context . new ( ) iex&gt; parser = digit ( ) iex&gt; parser . ( context ) % Context { status : { :error , :unexpected_eoi } , message : &quot;Unexpected end of input&quot; , char : 0 , input : &quot;&quot; , index : 0 , line : 1 , col : 1 }","ref":"Ergo.Terminals.html#digit/0","title":"Ergo.Terminals.digit/0","type":"function"},{"doc":"The eoi parser is a terminal parser that checks whether the input has been fully consumed. If there is input remaining to be parsed the return context status is set to :error. Examples iex&gt; alias Ergo.Context iex&gt; import Ergo.Terminals iex&gt; context = Context . new ( ) iex&gt; parser = eoi ( ) iex&gt; parser . ( context ) % Context { status : :ok } iex&gt; alias Ergo.Context iex&gt; import Ergo.Terminals iex&gt; context = Context . new ( &quot;Hello World&quot; ) iex&gt; parser = eoi ( ) iex&gt; parser . ( context ) % Context { status : { :error , :not_eoi } , message : &quot;Input not empty: Hello World…&quot; , input : &quot;Hello World&quot; }","ref":"Ergo.Terminals.html#eoi/0","title":"Ergo.Terminals.eoi/0","type":"function"},{"doc":"The literal/1 parser matches the specified string character by character. Examples iex&gt; alias Ergo.Context iex&gt; import Ergo.Terminals iex&gt; context = Context . new ( &quot;Hello World&quot; ) iex&gt; parser = literal ( &quot;Hello&quot; ) iex&gt; parser . ( context ) % Context { status : :ok , input : &quot; World&quot; , ast : &quot;Hello&quot; , char : ?o , index : 5 , line : 1 , col : 6 } iex&gt; alias Ergo.Context iex&gt; import Ergo.Terminals iex&gt; context = Context . new ( &quot;Hello World&quot; ) iex&gt; parser = literal ( &quot;Hellx&quot; ) iex&gt; parser . ( context ) % Context { status : { :error , :unexpected_char } , message : &quot;Expected: x Actual: o&quot; , input : &quot;o World&quot; , ast : [ ?l , ?l , ?e , ?H ] , char : ?l , index : 4 , line : 1 , col : 5 }","ref":"Ergo.Terminals.html#literal/2","title":"Ergo.Terminals.literal/2","type":"function"},{"doc":"The wc/0 parser parses a word character and is analagous to the \\w regular expression. Examples iex&gt; alias Ergo.Context iex&gt; import Ergo.Terminals iex&gt; context = Context . new ( &quot;Hello World&quot; ) iex&gt; parser = wc ( ) iex&gt; parser . ( context ) % Context { status : :ok , char : ?H , ast : ?H , input : &quot;ello World&quot; , index : 1 , col : 2 } iex&gt; alias Ergo.Context iex&gt; import Ergo.Terminals iex&gt; context = Context . new ( &quot;0 World&quot; ) iex&gt; parser = wc ( ) iex&gt; parser . ( context ) % Context { status : :ok , char : ?0 , ast : ?0 , input : &quot; World&quot; , index : 1 , col : 2 } iex&gt; alias Ergo.Context iex&gt; import Ergo.Terminals iex&gt; context = Context . new ( &quot;_Hello&quot; ) iex&gt; parser = wc ( ) iex&gt; parser . ( context ) % Context { status : :ok , char : ?_ , ast : ?_ , input : &quot;Hello&quot; , index : 1 , col : 2 } iex&gt; alias Ergo.Context iex&gt; import Ergo.Terminals iex&gt; context = Context . new ( &quot; Hello&quot; ) iex&gt; parser = wc ( ) iex&gt; parser . ( context ) % Context { status : { :error , :unexpected_char } , message : &quot;Expected: [0..9, a..z, A..Z, _] Actual: &quot; , input : &quot; Hello&quot; }","ref":"Ergo.Terminals.html#wc/0","title":"Ergo.Terminals.wc/0","type":"function"},{"doc":"The ws/0 parser accepts a white space character and is equivalent to the \\s regular expression. Examples iex&gt; alias Ergo.Context iex&gt; import Ergo.Terminals iex&gt; context = Context . new ( &quot; World&quot; ) iex&gt; parser = ws ( ) iex&gt; parser . ( context ) % Context { status : :ok , char : ?\\s , ast : ?\\s , input : &quot;World&quot; , index : 1 , line : 1 , col : 2 } iex&gt; alias Ergo.Context iex&gt; import Ergo.Terminals iex&gt; context = Context . new ( &quot; \\t World&quot; ) iex&gt; parser = ws ( ) iex&gt; parser . ( context ) % Context { status : :ok , char : ?\\t , ast : ?\\t , input : &quot;World&quot; , index : 1 , line : 1 , col : 2 } iex&gt; alias Ergo.Context iex&gt; import Ergo.Terminals iex&gt; context = Context . new ( &quot; \\n World&quot; ) iex&gt; parser = ws ( ) iex&gt; parser . ( context ) % Context { status : :ok , char : ?\\n , ast : ?\\n , input : &quot;World&quot; , index : 1 , line : 2 , col : 1 } iex&gt; alias Ergo.Context iex&gt; import Ergo.Terminals iex&gt; context = Context . new ( &quot;Hello World&quot; ) iex&gt; parser = ws ( ) iex&gt; parser . ( context ) % Context { status : { :error , :unexpected_char } , message : &quot;Expected: [ \\s , \\t , \\r , \\n , \\v ] Actual: H&quot; , input : &quot;Hello World&quot; }","ref":"Ergo.Terminals.html#ws/0","title":"Ergo.Terminals.ws/0","type":"function"},{"doc":"","ref":"Ergo.Utils.html","title":"Ergo.Utils","type":"module"},{"doc":"Examples iex&gt; Ergo.Utils . char_to_string ( ?H ) &quot;H&quot; iex&gt; Ergo.Utils . char_to_string ( ?h ) &quot;h&quot;","ref":"Ergo.Utils.html#char_to_string/1","title":"Ergo.Utils.char_to_string/1","type":"function"}]